# -*- coding:cp1252 -*-

import datetime
import os
import psyco
import re
import shelve

import es
import cfglib
import gamethread
import keyvalues
import langlib
import popuplib
import usermsg

from colormsglib import ColorMsg

psyco.full()

info = es.AddonInfo()
info.name = "TS_CONNECT"
info.version = "2.0"
info.author = "EmbouT"
info.url = "http://addons.eventscripts.com/addons/view/ts_connect"
info.description = "Connection to teamspeak"
info.tags = "teamspeak, franais, french"

addonPath = es.getAddonPath('ts_connect')
language = langlib.Strings(addonPath + '/config_languages.ini')
lang = es.local_language()
config = language['config']
title = config['title']
description = config['description']
comment = config['comment']
dash = "-" * 10

cfg = cfglib.AddonCFG(addonPath + "/ts_connect.cfg")
cfg.text("./addons/eventscripts/ts_connect/ts_connect.cfg")
cfg.text("")
cfg.text("*" * 70)
cfg.text(" " * 28 + info.name + " " + info.version)
cfg.text("*" * 70)
cfg.text("")
cfg.text(info.url)
cfg.text("")
for lang_ in config["info_language"]:
    if lang_ != lang:
        cfg.text(config['info_language'][lang_])
cfg.text("\n")
cfg.text("*" * 70)
cfg.text(" " * 25 + "=== %s ===" % title['commands'][lang])
cfg.text("*" * 70)
cfg.text("")
cfg.text(comment['commands'][lang])
cfg.cvar("ts_connect_connect_cmd", "ts", description['connect'][lang])
cfg.text(comment['connect'][lang])
cfg.cvar("ts_connect_nick_cmd", "tsnick", description['nick'][lang])
cfg.cvar("ts_connect_login_cmd", "tslogin", description['login'][lang])
cfg.cvar("ts_connect_password_cmd", "tspass", description['password'][lang])
cfg.cvar("ts_connect_help_cmd", 'tshelp', description['help'][lang])
cfg.cvar("ts_connect_settings_cmd", "tssettings", description['settings'][lang])
cfg.text(comment['settings_1'][lang])
cfg.text("\t * %s" % comment['settings_2'][lang])
cfg.text("\t * %s" % comment['settings_3'][lang])
cfg.text("\t * %s" % comment['settings_4'][lang])
cfg.text("\t * %s" % comment['settings_5'][lang])
cfg.text("\n")
cfg.text("*" * 70)
cfg.text(" " * 12 + "=== %s ===" % title['server'][lang])
cfg.text("*" * 70)
cfg.text("")
serverurl = cfg.cvar("ts_connect_server_url",
                     "92.68.1.83:8767", description['serverurl'][lang])
cfg.text('%s ts_connect_server_url "embout-ts.game-server.cc:8767"'
         % comment['serverurl'][lang])
serverpass = cfg.cvar("ts_connect_server_passwword",
                      "0", description['serverpw'][lang])
cfg.text("0 %s" % comment['notpassword'][lang])
cfg.text(dash)
joinchannel = cfg.cvar("ts_connect_join_channel",
                       "0", description['channel'][lang])
cfg.text("0 => %s" % comment['channel_1'][lang])
cfg.text("1 => %s" % comment['channel_2'][lang])
cfg.text('"%s" => %s' % (comment['channel_3'][lang],
                         comment['channel_4'][lang]))
cfg.text(comment['channel_5'][lang])
cfg.text(comment['channel_6'][lang])
joinchannelpass = cfg.cvar("ts_connect_join_channel_password",
                           "0", description['channelpw'][lang])
cfg.text(comment['channelpw'][lang])
cfg.text("0 %s" % comment['notpassword'][lang])
cfg.text(dash)
cfg.text("")
cfg.text(comment['channelteam_1'][lang])
cfg.text(comment['channelteam_2'][lang])
cfg.text(comment['channelteam_3'][lang])
cfg.text(comment['channelteam_4'][lang])
cfg.text("")
channelct = cfg.cvar("ts_connect_channel_ct",
                     "counter-terrorists", description['channelct'][lang])
channelctpass = cfg.cvar("ts_connect_channel_ct_password",
                         "0", description['channelctpw'][lang])
cfg.text("0 %s" % comment['notpassword'][lang])
cfg.text(dash)
channelt = cfg.cvar("ts_connect_channel_t",
                    "terrorists", description['channelt'][lang])
channeltpass = cfg.cvar("ts_connect_channel_t_password",
                        "0", description['channeltpw'][lang])
cfg.text("0 %s" % comment['notpassword'][lang])
cfg.text(dash)
channelspec = cfg.cvar("ts_connect_channel_spect",
                       "spectators", description['channelspec'][lang])
channelspecpass = cfg.cvar("ts_connect_channel_spec_password",
                           "0", description['channelspecpw'][lang])
cfg.text("0 %s" % comment['notpassword'][lang])
cfg.text("\n")
cfg.text("*" * 70)
cfg.text(" " * 25 + "=== %s ===" % title['options'][lang])
cfg.text("*" * 70)
cfg.text("")
infomsg = cfg.cvar("ts_connect_welcome_message",
                   2, description['welcome'][lang])
cfg.text(comment['welcome_1'][lang])
cfg.text(comment['welcome_2'][lang])
cfg.text(comment['welcome_3'][lang])
infotype = cfg.cvar("ts_connect_info_type", 2, description['infotype'][lang])
cfg.text(comment['infotype_1'][lang])
cfg.text(comment['infotype_2'][lang])
prune = cfg.cvar("ts_connect_prune_database", 30 , description['prune'][lang])
cfg.text("0 = %s" % comment['prune_1'][lang])
cfg.text(comment['prune_2'][lang])
autoswitch = cfg.cvar("ts_connect_switch_channel",
                      1, description['autoswitch'][lang])
cfg.text(comment['enabledisable'][lang])
cfg.text("'ts_connect_join_channel' %s" % comment['mustbeset'][lang])
cfg.text(comment['worksonly'][lang])
notallowed = re.compile("\\(\\)\\[\\]\\{\\}")
signeascii = "$ + < = > ~ ! \" # % & ' ( ) * , - . / : ; ? @ [ \ ] _ { | }"
signeutf1 = "                         "
signeutf2 = "                        "
charutf1 = "                 "
charutf2 = "                 "
asciionly = cfg.cvar("ts_connect_ascii_only", 0, description['asciionly'][lang])
cfg.text("1 = %s" % comment['asciionly_1'][lang])
cfg.text("\t\t* %s" % comment['asciionly_2'][lang])
cfg.text("\t\t* %s" % comment['asciionly_3'][lang])
cfg.text('\t\t* %s %s "' % (comment['asciionly_4'][lang], signeascii))
cfg.text(comment['asciionly_5'][lang])
cfg.text("")
cfg.text("0 = unicode")
cfg.text("\t\t %s" % comment['asciionly_6'][lang])
cfg.text("\t\t * %s" % charutf1)
cfg.text("\t\t * %s" % charutf2)
cfg.text("\t\t * %s" % signeutf1)
cfg.text("\t\t * %s" % signeutf2)
cfg.write()

del config
del title
del description
del comment

server_var = es.ServerVar
event_var = es.getEventInfo
maxlenght = server_var('ts_connect_max_lenght',
                       30, "Max chars for nickname, login and password")
v = server_var("ts_connect_v")
connectcmd = nickcmd = logincmd = passwordcmd = helpcmd = settingcmd = ""
v.set("2.0")
cmdlist = {}
userslist = {}
popuplist = set()
listenlist = set()
teamchannel = {1: (channelspec, channelspecpass),
               2: (channelt, channeltpass),
               3: (channelct, channelctpass)}

language = langlib.Strings(addonPath + '/popup_languages.ini')
db = shelve.open(addonPath + '/ts_user_db.dat', writeback=True)


class _TSUser(object):

    def __init__(self, userid):
        self.userid = int(userid)
        self.steamid = es.getplayersteamid(userid)
        self.lang = langlib.getLangAbbreviation(es.getclientvar(userid,
                                                                "cl_language"))
        self.nick = None
        self.login = None
        self.password = None
        self.advert = False
        self.connected = False
        self.autoconnect = False
        self.cmd = None
        self.menuid = "%s_ts_connect_menu" % userid
        self.lastdate = datetime.date.today()

    def __getitem__(self, name):
        return getattr(self, name)

    def __setitem__(self, name, value):
        setattr(self, name, value)

    def autoConnect(self):
        if self.autoconnect and not self.connected:
            self.connect()

    def connect(self):
        if self.nick is None:
            username = es.getplayername(self.userid)
            v = getBadChar(username)
            if v is not None:
                self.cmd = "connect"
                self.menuNoValid(v, username)
                return
            self.nick = username
        connectUser(self.userid, self.nick, self.login, self.password)
        self.connected = True

    def disconnect(self):
        if self.connected:
            usermsg.motd(self.userid, 2, 'TS', "teamspeak://disconnect", False)
            self.connected = False

    def getMenu(self):
        if self.menuid in popuplist:
            popuplib.unsendname(self.menuid, self.userid)
        menu = popuplib.create(self.menuid)
        menu.menuselect = menuChoice
        menu.enablekeys = "0"
        addMenu(menu.name)
        return menu

    def menuWelcome(self):
        if infomsg == 1 or (infomsg == 2 and not self.advert):
            if infotype in (0, 2):
                menu = self.getMenu()
                username = es.getplayername(self.userid)
                menu.addline(language("menuwelcomeline1",
                                      {"username": username}, self.lang))
                menu.addline(language("menuwelcomeline2",
                                      {"command": connectcmd}, self.lang))
                menu.addline(language("menuwelcomeline3",
                                      {"command": helpcmd}, self.lang))
                menu.timeout('view', 5)
                self.advert = True
                menu.send(self.userid)
            if infotype in (1, 2):
                ColorMsg(language("menuwelcomeline2",
                                  {"command": "#blue%s #orange" % connectcmd},
                                  self.lang)).tell(self.userid)
                ColorMsg(language("menuwelcomeline3",
                                  {"command": "#blue%s #orange" % helpcmd},
                                  self.lang)).tell(self.userid)

    def menuItem(self, cmd):
        self.cmd = cmd
        if cmd == "login" and self.nick is None:
            username = es.getplayername(self.userid)
            v = getBadChar(username)
            if v is not None:
                self.menuNoValid(v, username)
                return
            else:
                self.nick = username
        if cmd == "password":
            if self.login is None:
                self.menuNoValid()
                return
        menu = self.getMenu()
        item = language(cmd, None, self.lang)
        menu.addline(language("regitemtitle", {'item': item}, self.lang))
        menu.addline(dash)
        menu.addline(language("typeitem", {'item': item}, self.lang))
        if self[cmd]:
            menu.modline(1, language("changeitemtitle",
                                     {'item': item}, self.lang))
            menu.insline(2, "%s %s" % (language("currentitem", {'item': item},
                                                self.lang), self[cmd]))
        if cmd == "nick":
            menu.addline(dash)
            menu.addline(language("allowedchar", None, self.lang))
            menu.addline("aA <> zZ 0 <> 9")
            menu.addline(signeascii.replace(" ", ""))
            if not int(asciionly):
                menu.addline("%s" % signeutf1.replace(" ", "").decode('cp1252'))
                menu.addline("%s" % signeutf2.replace(" ", "").decode('cp1252'))
                menu.addline("%s" % charutf1.replace(" ", "").decode('cp1252'))
                menu.addline("%s" % charutf2.replace(" ", "").decode('cp1252'))
        menu.addline(dash)
        menu.addline("0. %s" % language("buttoncancel", None, self.lang))
        menu.select(10, delListen)
        menu.send(self.userid)
        gamethread.delayed(0.5, addListen, self.userid)

    def menuConfirm(self, text):
        cmd = self.cmd
        self.cmd = None
        item = language(cmd, None, self.lang)
        menu = popuplib.find(self.menuid)
        if not self[cmd]:
            menu.modline(3, language("successitem", {"item": item}, self.lang))
            menu.insline(4, "%s = %s" % (item, text))
            menu.modline(6, "->8. %s" % (language("buttondisplaymenusetting",
                                         None, self.lang)))
            menu.addline("0. %s" % language("buttonclose", None, self.lang))
            s = 7
        else:
            menu.modline(2, "%s %s" % (language("olditem", {'item': item},
                                                self.lang), self[cmd]))
            menu.modline(4, language("successnewitem",
                                     {"item": item}, self.lang))
            menu.insline(5, "%s %s" % (language("newitem", {'item': item},
                                                self.lang), text))
            menu.modline(7, "->8. %s" % (language("buttondisplaymenusetting",
                                         None, self.lang)))
            menu.addline("0. %s" % language("buttonclose", None, self.lang))
            s = 8
        menu.enablekeys += "8"
        self[cmd] = text
        if cmd == "login":
            b = language("buttonsetpassword", None, self.lang)
            if self.password is not None:
                b = language("buttonchangepassword", None, self.lang)
            menu.insline(s-1, "->1. %s" % b)
            menu.select(1, cmdPassword)
            menu.enablekeys += "1"
        elif cmd == "nick":
            r = 4 if int(asciionly) else 8
            for l in xrange(r):
                menu.delline(s)
        menu.select(8, cmdSettings)
        menu.update(self.userid)

    def menuSettings(self):
        menu = self.getMenu()
        menu.addline(language("menusettingusertitle", None, self.lang))
        menu.addline(language("menusettinguserline1", None, self.lang))
        n = self.nick
        if n is None:
            n = language("itemnotdefined", None, self.lang)
        menu.addline("->1. %s : %s" % (language("nick", None, self.lang), n))
        menu.select(1, cmdNick)
        if self.nick is not None:
            n = self.login
            if n is None:
                n = language("itemnotdefined", None, self.lang)
            menu.addline("->2. %s : %s" % (language("login",
                                                    None, self.lang), n))
            menu.select(2, cmdLogin)
            n = self.password
            if n is None:
                n = language("itemnotdefined", None, self.lang)
            menu.addline("->3. %s : %s" % (language("password",
                                                    None, self.lang), n))
            menu.select(3, cmdPassword)
            n = language("yes", None, self.lang)
            if not self.autoconnect:
                n = language("no", None, self.lang)
            menu.addline("->4. %s : %s" % (language("autoconnect",
                                                    None, self.lang), n))
            menu.select(4, toggleAutoConnect)
            menu.addline(dash)
            menu.addline("->8. %s" % language("buttondeleteitem", None,
                                              self.lang))
            menu.select(8, delItem)
            menu.enablekeys += "12348"
        else:
            menu.addline(language("neednickforoption", None, self.lang))
            na = language("notavailable", None, self.lang)
            menu.addline("2. %s : %s" % (language("login",
                                                  None, self.lang), na))
            menu.addline("3. %s : %s" % (language("password",
                                                  None, self.lang), na))
            menu.addline("4. %s : %s" % (language("autoconnect",
                                                  None, self.lang), na))
            menu.addline(dash)
            menu.enablekeys += "1"
        if not self.connected:
            menu.addline("->9. %s" % language("buttonconnect", None, self.lang))
            menu.select(9, cmdConnect)
        else:
            menu.addline("->9. %s" % language("buttondisconnect",
                                              None, self.lang))
            menu.select(9, userDisconnect)
        menu.enablekeys += "9"
        menu.addline("0. %s" % language("buttonclose", None, self.lang))
        menu.send(self.userid)

    def menuDelete(self):
        menu = self.getMenu()
        menu.addline(language("menudeleteitemtitle", None, self.lang))
        menu.addline(language("menudeleteitemline1", None, self.lang))
        menu.addline(dash)
        menu.addline("->1. %s : %s" % (language("nick", None, self.lang),
                                       self.nick))
        menu.select(1, delItem)
        if self.login is not None:
            menu.addline(language("menudeleteitemline2", None, self.lang))
            menu.addline("->2. %s : %s" % (language("login", None, self.lang),
                                           self.login))
            menu.select(2, delItem)
            menu.enablekeys += "2"
            if self.password is not None:
                menu.addline(language("menudeleteitemline3", None, self.lang))
                menu.addline("->3. %s : %s"
                             % (language("password", None, self.lang),
                                self.password))
                menu.select(3, delItem)
                menu.enablekeys += "3"
        menu.addline(dash)
        menu.addline("->6. %s" % language("buttonprev", None, self.lang))
        menu.select(6, cmdSettings)
        menu.enablekeys += "16"
        menu.addline("0. %s" % language("buttonclose", None, self.lang))
        menu.send(self.userid)

    def menuNoValid(self, car=None, text=None):
        cmd = self.cmd
        self.cmd = None
        menu = self.getMenu()
        if cmd == "password":
            menu.addline(language("nologin", None, self.lang))
            menu.addline(language("needloginforpassword", None, self.lang))
            menu.addline(dash)
            menu.addline("->1. %s" % language("buttonsetlogin",
                                              None, self.lang))
            menu.select(1, cmdLogin)
        else:
            if cmd == "nick":
                if self.nick is not None:
                    menu.addline(language("badnewnick",
                                          {"nick": text}, self.lang))
                else:
                    menu.addline(language("badnick", {"nick": text}, self.lang))
                menu.addline(" ".join(car))
                menu.addline("->1. %s" % language("buttonretry",
                                                  None, self.lang))
            else:
                menu.addline(language("nonick", None, self.lang))
                menu.addline(language("badnickingame",
                                      {"username": text}, self.lang))
                menu.addline(" ".join(car))
                menu.addline(language("neednickforconnect", None, self.lang))
                if cmd == 'login':
                    menu.modline(4, language("neednickforlogin",
                                             None, self.lang))
                menu.addline("->1. %s" % language("buttonsetnick",
                                                  None, self.lang))
            menu.select(1, cmdNick)
        menu.addline("-"*10)
        menu.addline("0. %s" % language("buttoncancel", None, self.lang))
        menu.enablekeys = "012"
        menu.send(self.userid)

def load():
    global cmdlist, connectcmd, nickcmd, logincmd
    global passwordcmd, charcmd, helpcmd, settingcmd
    v.addFlag("replicated")
    cfg.execute()
    connectcmd = str(server_var("ts_connect_connect_cmd"))
    nickcmd = str(server_var("ts_connect_nick_cmd"))
    logincmd = str(server_var("ts_connect_login_cmd"))
    passwordcmd = str(server_var("ts_connect_password_cmd"))
    helpcmd = str(server_var("ts_connect_help_cmd"))
    settingcmd = str(server_var("ts_connect_settings_cmd"))
    cmdlist = {connectcmd: "cmdConnect",
               nickcmd: "cmdNick",
               logincmd: "cmdLogin",
               passwordcmd: "cmdPassword",
               helpcmd: "cmdHelp",
               settingcmd: "cmdSettings"}
    oldDB()
    init()

def es_map_start(e):
    pruneDB()

def player_team(e):
    if not int(event_var('disconnect')):
        player = getPlayer(event_var('userid'))
        team = int(event_var('team'))
        oldteam = int(event_var('oldteam'))
        if oldteam == 0:
            player.menuWelcome()
            player.autoConnect()
        elif team != oldteam and str(joinchannel) == '1' and \
             int(autoswitch) and player.connected:
            player.connect()

def player_disconnect(e):
    global userslist
    userid = event_var('userid')
    steamid = event_var('es_steamid')
    setData(userslist[steamid])
    del(userslist[steamid])
    delListen(userid)
    delMenu("%s_ts_connect_menu" % userid)

def unload():
    init(False)
    for userid in listenlist:
        delListen(userid)
    db.close()
    v.removeFlag("replicated")

def addListen(userid):
    global listenlist
    listenlist.add(userid)
    if len(listenlist) == 1:
        es.addons.registerSayFilter(hookChat)

def addMenu(popupname):
    global popuplist
    popuplist.add(popupname)

def cmdConnect(userid=0, choice=0, popupid=""):
    if not userid:
        userid = es.getcmduserid()
    player = getPlayer(userid)
    if not player.connected:
        player.connect()

def cmdHelp(userid=0):
    if not userid:
        userid = es.getcmduserid()
    menu = popuplib.find("ts_connect_menu_help")
    if not popuplib.isqueued(menu.name, userid):
        menu.send(userid)

def cmdLogin(userid=0, choice=0, popupid=""):
    if not userid:
        userid = es.getcmduserid()
    getPlayer(userid).menuItem("login")

def cmdNick(userid=0, choice=0, popupid=""):
    if not userid:
        userid = es.getcmduserid()
    getPlayer(userid).menuItem("nick")

def cmdPassword(userid=0, choice=0, popupid=""):
    if not userid:
        userid = es.getcmduserid()
    getPlayer(userid).menuItem("password")

def cmdSettings(userid=0, choice=0, popupid=""):
    if not userid:
        userid = es.getcmduserid()
    getPlayer(userid).menuSettings()

def connectUser(userid, nick, login, password):
    link = "teamspeak://%s/" % serverurl
    if password is not None and login is not None:
        link += "?loginname=%s?password=%s" % (login, password)
    elif serverpass != "0":
        login = None
        link += "?password=%s" % serverpass
    link += "?nickname=%s" % encodeNick(re.sub(notallowed, "|", nick))
    channel = subchannel = channelpassword = ""
    if joinchannel != '0':
        if joinchannel != '1':
            channel = str(joinchannel)
            channelpassword =  str(joinchannelpass)
        else:
            c = teamchannel[es.getplayerteam(userid)]
            channel = str(c[0])
            channelpassword = str(c[1])
    if channel.endswith(']') and not channel.startswith("["):
        subchannel = channel[channel.find('[')+1:-1]
        channel = channel[:channel.find('[')]
    if channel and channel != "0":
        link += "?channel=%s" % channel
        if subchannel:
            link += "?subchannel=%s" % subchannel
        if channelpassword and channelpassword != "0":
            link += "?channelpassword=%s" % channelpassword
    usermsg.motd(userid, 2, 'TS', link, False)

def delItem(userid, choice, popupid):
    player = getPlayer(userid)
    if choice == 8:
        player.menuDelete()
    elif choice == 1:
        player.nick = player.login = player.password = None
        player.menuSettings()
    elif choice == 2:
        player.login = player.password = None
        player.menuDelete()
    elif choice == 3:
        player.password = None
        player.menuDelete()

def delListen(userid, c=0, p=None):
    global listenlist
    if userid in listenlist:
        listenlist.remove(userid)
        if not listenlist:
            es.addons.unregisterSayFilter(hookChat)

def delMenu(popupname):
    global popuplist
    if popupname in popuplist:
        popuplist.remove(popupname)
        popuplib.delete(popupname)

def encodeNick(nick):
    return nick.decode('utf8').encode("cp1252")

def getBadChar(nick):
    filterchar = filter(lambda n: n not in(127,129,141,143,144,157),
                        xrange(32, 127 if asciionly else 256))
    if asciionly == 0:
        filterchar += [338, 339, 352, 353, 376, 381, 382, 402, 710, 732, 8211,
                       8212, 8216, 8217, 8218, 8220, 8221, 8222, 8224, 8225,
                       8226, 8230, 8240, 8249, 8250, 8364, 8482]
    r = []
    for car in nick.decode('utf8'):
        if ord(car) not in filterchar:
            r += car
    return r

def getData(steamid):
    if steamid in db:
        user = db[steamid]
        player = _TSUser(es.getuserid(steamid))
        player.nick = user['nick']
        player.login = user['login']
        player.password = user['password']
        player.advert = user['advert']
        player.autoconnect = user['auto']
        return player
    return None

def getPlayer(userid):
    steamid = es.getplayersteamid(userid)
    if not steamid in userslist:
        user = getData(steamid)
        if not user:
            userslist[steamid] = _TSUser(userid)
        else:
            userslist[steamid] = user
    return userslist[steamid]

def hookChat(userid, text, teamonly):
    if userid in listenlist:
        player = getPlayer(userid)
        t = text.strip('"')
        if len(t.decode('utf8')) <= int(maxlenght):
            if t.replace(' ', '').replace('', ''):
                if not t in cmdlist:
                    v = None
                    if player.cmd == "nick":
                        v = getBadChar(t)
                    if v:
                        player.menuNoValid(v, t)
                    else:
                        player.menuConfirm(t)
                    delListen(userid)
                    userid = 0
            else:
                es.playsound(userid, "buttons/button8.wav", 1)
                item = language(player.cmd, None, player.lang)
                es.tell(userid, language("notspaceonly",
                                         {'item': item}, player.lang))
                userid = 0
        else:
            es.playsound(userid, "buttons/button8.wav", 1)
            item = language(player.cmd, None, player.lang)
            es.tell(userid, language("toolong",
                                     {'item': item, 'max': maxlenght},
                                     player.lang))
            userid = 0
    return userid, text, teamonly

def init(loading=True):
    for userid in es.getUseridList():
        if loading:
            getPlayer(userid)
        else:
            setData(userslist[es.getplayersteamid(userid)])

    for cmd in cmdlist:
        if loading:
            if not es.exists("saycommand", cmd):
                es.regsaycmd(cmd, "ts_connect/%s" % cmdlist[cmd])
            if not es.exists("clientcommand", cmd):
                es.regclientcmd(cmd, "ts_connect/%s" % cmdlist[cmd])
        else:
            es.unregsaycmd(cmd)
            es.unregclientcmd(cmd)

    if loading:
        menu = popuplib.create("ts_connect_menu_help")
        menu.addline(popuplib.langstring('', language['menuhelpline1']))
        menu.addline(popuplib.langstring('', language['menuhelpline2']))
        menu.addline(popuplib.langstring('', language['menuhelpline3']))
        menu.addline(popuplib.langstring('', language['menuhelpline4']))
        menu.addline(popuplib.langstring('', language['menuhelpline5'], ','))
        menu.addline(popuplib.langstring('', language['menuhelpline6']))
        menu.addline(popuplib.langstring("->1. ",
                                         language["buttondisplaymenucmd"]))
        menu.submenu(1, "ts_connect_menu_cmd")
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("0. ", language["buttonclose"]))
        menu.enablekeys = "01"
        menu.menuselect = menuChoice
        addMenu(menu.name)

        menu = popuplib.create("ts_connect_menu_cmd")
        menu.addline(popuplib.langstring("", language["menucmdtitle"]))
        menu.addline(popuplib.langstring("", language["menucmdline1"]))
        menu.addline(popuplib.langstring("->1. (%s) - " % connectcmd,
                                         language["buttondisplaymenuconnect"]))
        menu.submenu(1, "ts_connect_menu_connect")
        menu.addline(popuplib.langstring("->2. (%s) - " % nickcmd,
                                         language["buttonsetnick"]))
        menu.submenu(2, "ts_connect_menu_nick")
        menu.addline(popuplib.langstring("->3. (%s) - " % logincmd,
                                         language["buttonsetlogin"]))
        menu.submenu(3, "ts_connect_menu_login")
        menu.addline(popuplib.langstring("->4. (%s) - " % passwordcmd,
                                         language["buttonsetpassword"]))
        menu.submenu(4, "ts_connect_menu_password")
        menu.addline(popuplib.langstring("->5. (%s) - " % settingcmd,
                                         language["buttondisplaymenusetting"]))
        menu.submenu(5, "ts_connect_menu_setting")
        menu.addline(popuplib.langstring("->6. (%s) - " % helpcmd,
                                         language["buttondisplaymenuhelp"]))
        menu.submenu(6, "ts_connect_menu_help1")
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("0. ", language["buttonclose"]))
        menu.enablekeys = "0123456"
        menu.menuselect = menuChoice
        addMenu(menu.name)

        menu = popuplib.create("ts_connect_menu_connect")
        menu.addline(popuplib.langstring("", language["menuconnecttitle"]))
        menu.addlineAll(connectcmd)
        menu.addline(popuplib.langstring("", language["commonmenuline1"], ","))
        menu.addline(popuplib.langstring("", language["menuconnectline1"]))
        menu.addline(popuplib.langstring("", language["commonmenuline2"]))
        menu.addline(popuplib.langstring("", language["commonmenuline3"]))
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("->1. ", language["buttonconnect"]))
        menu.select(1, cmdConnect)
        menu.addline(popuplib.langstring("->8. ", language["buttonprev"]))
        menu.submenu(8, "ts_connect_menu_cmd")
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("0. ", language["buttonclose"]))
        menu.enablekeys = "018"
        menu.menuselect = menuChoice
        addMenu(menu.name)

        menu = popuplib.create("ts_connect_menu_nick")
        menu.addline(popuplib.langstring("", language["menunicktitle"]))
        menu.addlineAll(nickcmd)
        menu.addline(popuplib.langstring("", language["commonmenuline1"], ","))
        menu.addline(popuplib.langstring("", language["menunickline1"]))
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("->1. ", language["buttonsetnick"]))
        menu.select(1, cmdNick)
        menu.addline(popuplib.langstring("->8. ", language["buttonprev"]))
        menu.submenu(8, "ts_connect_menu_cmd")
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("0. ", language["buttonclose"]))
        menu.enablekeys = "018"
        menu.menuselect = menuChoice
        addMenu(menu.name)

        menu = popuplib.create("ts_connect_menu_login")
        menu.addline(popuplib.langstring("", language["menulogintitle"]))
        menu.addlineAll(logincmd)
        menu.addline(popuplib.langstring("", language["commonmenuline1"], ","))
        menu.addline(popuplib.langstring("", language["menuloginline1"]))
        menu.addline(popuplib.langstring("", language["commonmenuline2"]))
        menu.addline(popuplib.langstring("", language["commonmenuline3"]))
        menu.addline(popuplib.langstring("", language["menuloginline2"]))
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("->1. ", language["buttonsetlogin"]))
        menu.select(1, cmdLogin)
        menu.addline(popuplib.langstring("->8. ", language["buttonprev"]))
        menu.submenu(8, "ts_connect_menu_cmd")
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("0. ", language["buttonclose"]))
        menu.enablekeys = "018"
        menu.menuselect = menuChoice
        addMenu(menu.name)

        menu = popuplib.create("ts_connect_menu_password")
        menu.addline(popuplib.langstring("", language["menupasswordtitle"]))
        menu.addlineAll(passwordcmd)
        menu.addline(popuplib.langstring("", language["commonmenuline1"], ","))
        menu.addline(popuplib.langstring("", language["menupasswordline1"]))
        menu.addline(popuplib.langstring("", language["menupasswordline2"]))
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("->1. ",
                                         language["buttonsetpassword"]))
        menu.select(1, cmdPassword)
        menu.addline(popuplib.langstring("->8. ", language["buttonprev"]))
        menu.submenu(8, "ts_connect_menu_cmd")
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("0. ", language["buttonclose"]))
        menu.enablekeys = "018"
        menu.menuselect = menuChoice
        addMenu(menu.name)

        menu = popuplib.create("ts_connect_menu_setting")
        menu.addline(popuplib.langstring("", language["menusettingtitle"]))
        menu.addlineAll(settingcmd)
        menu.addline(popuplib.langstring("", language["commonmenuline1"], ","))
        menu.addline(popuplib.langstring("", language["menusettingline1"]))
        menu.addline(popuplib.langstring("", language["menusettingline2"]))
        menu.addline(popuplib.langstring("", language["menusettingline3"]))
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("->1. ",
                                         language["buttondisplaymenusetting"]))
        menu.select(1, cmdSettings)
        menu.addline(popuplib.langstring("->8. ", language["buttonprev"]))
        menu.submenu(8, "ts_connect_menu_cmd")
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("0. ", language["buttonclose"]))
        menu.enablekeys = "018"
        menu.menuselect = menuChoice
        addMenu(menu.name)

        menu = popuplib.create("ts_connect_menu_help1")
        menu.addline(popuplib.langstring("", language["menuhelp1title"]))
        menu.addlineAll(helpcmd)
        menu.addline(popuplib.langstring("", language["commonmenuline1"], ","))
        menu.addline(popuplib.langstring("", language["menuhelp1line1"]))
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("->8. ", language["buttonprev"]))
        menu.submenu(8, "ts_connect_menu_cmd")
        menu.addlineAll(dash)
        menu.addline(popuplib.langstring("0. ", language["buttonclose"]))
        menu.enablekeys = "08"
        menu.menuselect = menuChoice
        addMenu(menu.name)

    else:
        popuplib.delete(popuplist)

def menuChoice(userid, choice, popupid):
    if choice < 10:
        es.playsound(userid, "buttons/button14.wav", 1)
    else:
        es.playsound(userid, "buttons/combine_button7.wav", 1)

def oldDB():
    file_ = es.getAddonPath("ts_connect") + "/es_pseudo_ts_db.txt"
    if os.path.isfile(file_):
        group = keyvalues.KeyValues(filename=file_)
        for key in group:
            steamid = key.getName()
            db[steamid] = {}
            db[steamid]['nick'] = key['pseudo']
            db[steamid]['login'] = key['name'] if key["name"] != 0 else None
            db[steamid]['password'] = key['pass'] if key["pass"] != 0 else None
            db[steamid]['advert'] = False
            db[steamid]['auto'] = False
            db[steamid]['lastdate'] = datetime.date.today()
        os.rename(file_, file_.replace(".txt", ".old"))

def pruneDB():
    deletelist = []
    if int(prune) > 0:
        for steamid in db:
            if not steamid in userslist:
                if datetime.date.today() > \
                   (db[steamid]['lastdate'] + datetime.timedelta(int(prune))):
                    deletelist.append(steamid)
    for steamid in deletelist:
        del(db[steamid])
    db.sync()

def setData(player):
    if player.advert or player.nick is not None:
        if player.steamid not in db:
            db[player.steamid] = {}
        db[player.steamid]['nick'] = player.nick
        db[player.steamid]['login'] = player.login
        db[player.steamid]['password'] = player.password
        db[player.steamid]['advert'] = player.advert
        db[player.steamid]['auto'] = player.autoconnect
        db[player.steamid]['lastdate'] = player.lastdate
        db.sync()

def toggleAutoConnect(userid, choice, popupid):
    player = getPlayer(userid)
    player.autoconnect = not player.autoconnect
    player.menuSettings()

def userDisconnect(userid, choice, popupid):
    getPlayer(userid).disconnect()
